
function Skinner:Ash_DoTimer()

	--	Hook to skin the Main GUI
	self:SecureHook(DoTimer, "ShowGUI", function(this, ...)
-- 		self:Debug("DT_ShowGUI")
		if not DoTimerMenuFrame.skinned then
			for k, v in pairs({ DoTimerMenuFrame:GetChildren() }) do
				if v.initialize then
					self:keepFontStrings(v)
				elseif v:GetFrameType() == "EditBox" then
					self:skinEditBox(v, {9})
				end
			end
			self:applySkin(DoTimerMenuFrame, true)
			DoTimerMenuFrame.skinned = true
		end
		end)
	
	--	Hook to skin the Timer GUI
	self:SecureHook(DoTimer, "ShowTimerGUI", function(this, ...)
-- 		self:Debug("DT_ShowTimerGUI")
		if not DoTimerTimerMenuFrame.skinned then
			for k, v in pairs({ DoTimerTimerMenuFrame:GetChildren() }) do
			if v.initialize then
					self:keepFontStrings(v)
				elseif v:GetFrameType() == "EditBox" then
					self:skinEditBox(v, {9})
				end
			end
			self:applySkin(DoTimerTimerMenuFrame, true)
			DoTimerTimerMenuFrame.skinned = true
		end
		end)

	--	Hook to skin the Profile GUI
	self:SecureHook(ProfileLib, "ShowGUI", function(this, ...)
-- 		self:Debug("PL_ShowGUI")
		if not ProfileMenuFrame.skinned then
			for k, v in pairs({ ProfileMenuFrame:GetChildren() }) do
			if v.initialize then
					self:keepFontStrings(v)
				elseif v:GetFrameType() == "EditBox" then
					self:skinEditBox(v, {9})
				end
			end
			self:applySkin(ProfileMenuFrame, true)
			ProfileMenuFrame.skinned = true
		end
		end)
	
	-- Hook these to Skin the DropDown frames
	self:SecureHook(DropDownLib, "CreateFrames", function(this, level, index)
-- 		self:Debug("DDL_CF: [%s, %s, %s]", this, level, index)
		local ddFrame = "DropDownLibList"..level
		if _G[ddFrame] and not self:IsHooked(_G[ddFrame], "OnShow") then
			self:HookScript(_G[ddFrame], "OnShow", function()
				self.hooks[_G[ddFrame]].OnShow()
				self:keepFontStrings(_G[ddFrame])
				_G[ddFrame.."Backdrop"]:Hide()
				_G[ddFrame.."MenuBackdrop"]:Hide()
				self:applySkin(_G[ddFrame])
				end)
		end
		end)
	
	--	Hook to skin the DOT Timers
	self:SecureHook(DoTimer, "CreateFrames", function(this, targets, timers)
-- 		self:Debug("DT_CF: [%d, %d]", targets, timers)
		targets = math.max(targets, this.libraries["TimerLib"].totaltargets)
		timers  = math.max(timers, this.libraries["TimerLib"].totaltargets)
		local targetframe = this.libraries["TimerLib"].targetframe
		local timerframe  = this.libraries["TimerLib"].timerframe
		for i = 1, targets do
			for id = 1, timers do
				self:glazeStatusBar(_G[targetframe..i..timerframe..id.."BarStatusFront"])
				self:glazeStatusBar(_G[targetframe..i..timerframe..id.."BarBackground"])
				self:applySkin(_G[targetframe..i..timerframe..id.."IconButton"])
			end	
		end
		end)
	
	self:skinTooltip(SpellSystemScanningFrame)
	
	if IsAddOnLoaded("Ash_Cooldowns") then
		--	Hook to skin the Cooldown Timers
		self:SecureHook(Cooldowns, "CreateFrames", function(this, targets, timers)
-- 			self:Debug("CT_CF: [%s, %s]", targets, timers)
			targets = math.max(targets, this.libraries["TimerLib"].totaltargets)
			timers  = math.max(timers, this.libraries["TimerLib"].totaltargets)
			local targetframe = this.libraries["TimerLib"].targetframe
			local timerframe  = this.libraries["TimerLib"].timerframe
			for i = 1, targets do
				for id = 1, timers do
					self:glazeStatusBar(_G[targetframe..i..timerframe..id.."BarStatusFront"])
					self:glazeStatusBar(_G[targetframe..i..timerframe..id.."BarBackground"])
					self:applySkin(_G[targetframe..i..timerframe..id.."IconButton"])
				end	
			end
			end)
		--	Hook to skin the Cooldowns GUI
		self:SecureHook(Cooldowns, "ShowGUI", function(this, ...)
-- 			self:Debug("CD_ShowGUI")
			if not CooldownsMenuFrame.skinned then
				for k, v in pairs({ CooldownsMenuFrame:GetChildren() }) do
					if v.initialize then
						self:keepFontStrings(v)
					elseif v:GetFrameType() == "EditBox" then
						self:skinEditBox(v, {9})
					end
				end
				self:applySkin(CooldownsMenuFrame, true)
				CooldownsMenuFrame.skinned = true
			end
			end)

	end

end
