
function Skinner:TourGuide()

	-- Find the OptionHouse library object
	for k, object in LibStub:IterateLibraries() do
-- 		self:Debug("LS_IL: [%s, %s]", k, object)
		if k == "OptionHouse-1.1" then
			self:SecureHook(object, "Open", function(this, ...)
-- 				self:Debug("OH Main Frame#1: [%s]", OptionHouseFrames.main)
				self:skinOptionHouse()
				self:Unhook(object, "Open")
				end)
		end
	end
	-- Hook this as well
	self:SecureHook(SlashCmdList, "OPTHOUSE", function()
-- 		self:Debug("OH SCL")
		self:skinOptionHouse()
		self:Unhook(SlashCmdList, "OPTHOUSE")
		end)

	-- Tour Guide Frames
	self:Hook(TourGuide, "CreateObjectivePanel", function(this, ...)
		local TGOPFrame = self.hooks[TourGuide].CreateObjectivePanel(this, ...)
		self:SecureHook(TGOPFrame, "Show", function(this, ...)
			self:moveObject(TGOPFrame, nil, nil, "-", 50)
			self:Unhook(TGOPFrame, "Show")
			end)
		local TGOPSB = self:getChild(TGOPFrame, 1) 
		self:keepFontStrings(TGOPSB)
		TGOPSB:GetThumbTexture():SetAlpha(1)
		self:skinUsingBD2(TGOPSB)
		self:Unhook(TourGuide, "CreateObjectivePanel")
		return TGOPFrame
		end, true)
	self:Hook(TourGuide, "CreateGuidesPanel", function(this, ...)
		local TGGPFrame = self.hooks[TourGuide].CreateGuidesPanel(this, ...)
		self:SecureHook(TGGPFrame, "Show", function(this, ...)
			self:moveObject(TGGPFrame, nil, nil, "-", 50)
			self:Unhook(TGGPFrame, "Show")
			end)
		self:Unhook(TourGuide, "CreateGuidesPanel")
		return TGGPFrame
		end, true)
	
	
	-- Status Frame
	local dbName = TourGuide.db.profile
	local sf
	if dbName.statusframepoint then 
		sf = self:findFrame2(UIParent, "Button", dbName.statusframepoint, UIParent, "TOPRIGHT", math.ceil(dbName.statusframex), math.ceil(dbName.statusframey))
	else	
		sf = self:findFrame2(UIParent, "Button", "BOTTOMRIGHT", QuestWatchFrame, "TOPRIGHT", 0, -15)
	end
-- 	self:Debug("TourGuide, StatusFrame: [%s]", sf)
	self:applySkin(sf)
	
end

function Skinner:skinOptionHouse()

	if OptionHouseFrames.skinned then return end
	
-- 	self:Debug("OH Main Frame: [%s]", OptionHouseFrames.main)
	local ohFrame = OptionHouseFrames.main
	ohFrame:SetHeight(ohFrame:GetHeight() * FyMult)
	self:keepFontStrings(ohFrame)
	-- move the title
	self:getRegion(ohFrame, 2):SetPoint("TOP", 0, -8)
	-- move the close button
	self:getChild(ohFrame, 2):SetPoint("TOPRIGHT", 0, 0)
	-- skin the tabs
	for i = 1, #ohFrame.tabs do
		local tabName = ohFrame.tabs[i]
		self:keepRegions(tabName, {1, 2}) -- N.B. region 1 is the Text, 2 is the highlight
		self:applySkin(tabName)
		if i == 1 then tabName:SetPoint("TOPLEFT", ohFrame, "BOTTOMLEFT", 15, 8) end
	end
	self:applySkin(ohFrame)
	
	-- Skin the Sub Frame
	local ohSubFrame = OptionHouseFrames.addon
	ohSubFrame:SetAllPoints(OptionHouseFrames.main)
	for i = 1, 15 do
		local ohSFbutton = ohSubFrame.buttons[i]
		if i == 1 then self:moveObject(ohSFbutton, nil, nil, "-", 50) end
		self:keepRegions(ohSFbutton, {2, 4}) -- N.B. region 2 is the Text, 4 is the highlight
		local ohSFBGNT = ohSFbutton:GetNormalTexture()
		self:Hook(ohSFBGNT, "SetAlpha", function(...) end, true) -- stop the textures being shown
	end
	self:keepFontStrings(ohSubFrame.scroll)
	ohSubFrame.scroll.bar:GetThumbTexture():SetAlpha(1)
	self:skinUsingBD2(ohSubFrame.scroll)
	self:skinEditBox(ohSubFrame.search, {9})

	OptionHouseFrames.skinned = true

end

